#include "JVM.h"

void wherepath(char * const path)
{
   gotoxy(1,1);

   for (int i = 0;i < 240;i++)
	   cprintf(" ");

	textcolor(4);
	gotoxy(28,2);
	cprintf("File name:                ");
	_setcursortype(_NORMALCURSOR);
	gotoxy(39,2);
	cscanf("%s",path);
	_setcursortype(_NOCURSOR);
}

void preint()
{
   int i;

   clrscr();
   textcolor(14);

   gotoxy(1,4);

   for (i = 1;i <= 80;i++)
	   cprintf("-");

   textcolor(11);
   gotoxy(5,24);
   cprintf("G: Go to memory");
   gotoxy(25,24);
   cprintf("O: Open file");
   gotoxy(43,24);
   cprintf("Enter: Next command");
   gotoxy(68,24);
   cprintf("Esc: Exit");

   textcolor(2);
   gotoxy(2,5);
   cprintf("pc: ");
   gotoxy(65,5);
   cprintf("sp: ");
   textcolor(6);
   gotoxy(71,7);
   cprintf("stack: ");
   gotoxy(2,7);
   cprintf("Memory: ");
   textcolor(12);
   gotoxy(12,5);
   cprintf("-->");

}

void getint(int & what)
{
	char mych = 0;
	what = 0;

	while(mych != '\r')
	{
		if(mych <= '9' && mych >= '0')
		{
			what *= 10;
			what += mych - '0';
			cprintf("%c",mych);
		}

		asm{
			mov	ah,0
			int 16h
			mov mych,al
		}
	}
}

char sure()
{
	textcolor(13 + BLINK);
	gotoxy(30,7);
	cprintf("Are you sure?[y/n]");

	char mych = 0;

	while(mych != 'y' && mych != 'Y' && mych != 'n' &&mych != 'N')
	{
		asm{
			mov	ah,0
			int 16h
			mov mych,al
		}
	}

	textcolor(5);
	gotoxy(30,7);

	for (int i = 0;i < 20;i++)
		cprintf(" ");

	if(mych == 'y' || mych == 'Y')
		return 1;
	else
		return 0;

//	return 0;
}

JVM::JVM(char * const path,int & phase)
{
	int howmuch,errorcount = 0;
	wherethemem = 0;
	pc = 0;
	sp = 15000;
	wide = 0;
	loadedfile = alljobs = NULL;
	mystream = NULL;

	preint();

	while(mystream == 0 && errorcount < 3)
	{
		if(phase != 1)
		{
			wherepath(path);
			errorcount++;
		}
		else
			phase++;


		mystream = fopen(path,"r+b");
		phase = 2;
	}

	if(mystream == 0)
	{
		*path = 0;
		return;
	}

	gotoxy(1,1);
	for (int i = 0;i < 240;i++)
	   cprintf(" ");

	textcolor(4);
	gotoxy(40 - (strlen(path) / 2),25);
	cprintf("%s",path);

	*path = 0;
	loadedfile = malloc(15000);

	if(!loadedfile)
	{
		finalize();
		return;
	}

	alljobs = new pointofunc [256];

	if(!alljobs)
	{
		finalize();
		return;
	}

	howmuch = fread(loadedfile,1,15000,mystream);

	if(howmuch != 15000)
	{
		finalize();
		return;
	}

	fclose(mystream);
	mystream = NULL;

	setinstructions();
	drawtable(0);
	messenger("",NULL,"");
	_setcursortype(_NOCURSOR);

	char mych;
	short behzad;

	while(1)
	{
		do{
			asm{
				mov	ah,0
				int 16h
				mov mych,al
			}
		}while(mych != 'G' && mych != 'g' && mych != 'O' && mych != 'o' && mych != 13 && mych != 27);

		switch(mych)
		{
		case '\r':
			behzad = 0;
			*(char *)&behzad = whosnext(1);
			(*(alljobs + behzad))(*this);
			drawtable(wherethemem);
			break;

		case 'G':
		case 'g':
			memmanager();
			break;

		case 'O':
		case 'o':
			if(sure())
			{
				clrscr();
				preint();
				*path = 1;
				goto outof;
			}
			break;

		case 27:
			if(sure())
				goto outof;

		default:
			break;

		}
	}
outof:
}

JVM::~JVM()
{
	textcolor(7);
	clrscr();
	_setcursortype(_NORMALCURSOR);

	finalize();
}

void JVM::pusher(int howlong,void * what)
{
	for(int count = howlong - 1;count >= 0;count--)
	{
		sp--;
		*((char *)loadedfile + sp) = *((char *)what + count);
	}
}

void JVM::poper(int howlong,void * what)
{
	for(int count = 0;count < howlong;count++)
	{
		*((char *)what + count) = *((char *)loadedfile + sp);
		sp++;
	}
}

char JVM::whosnext(int go)
{
	char retval = *((char *)loadedfile + pc);
	
	if(go)
		pc++;

	return retval;
}

void JVM::between(int howlong,void * fromwhere,void * towhere)
{
	for(int count = 0;count < howlong;count++)
		*((char *)towhere + count) = *((char *)fromwhere + count);
}

void JVM::revbetw(int howlong,void * fromwhere,void * towhere)
{
	for(int count = 0;count < howlong;count++)
		*((char *)towhere + howlong - count - 1) = *((char *)fromwhere + count);
}

void JVM::messenger(const char * mycommand,const short * index,const char * message,int size)
{
   int i;
   short behzad;

   textcolor(15);

   gotoxy(1,1);

   for (i = 0;i < 240;i++)
	   cprintf(" ");

   textcolor(9);
   gotoxy(40 - (strlen(mycommand) / 2) - (size / 2),1);
   cprintf("%s",mycommand);

   if(index != NULL)
   {
	   cprintf(" <");

	   for(i = 0;i < size;i++)
	   {		    
			if((unsigned short)*(index + i) < 16)
				cprintf("0");

		   cprintf("%X",*(index + i));
	   }

	   cprintf(">");
   }

   textcolor(15);
   gotoxy(1,2);
   cprintf("%s",message);

   textcolor(10);
   gotoxy(6,5);
   cprintf("     ");
   gotoxy(6,5);
   cprintf("%d",pc);
   gotoxy(70,5);
   cprintf("     ");
   gotoxy(70,5);
   cprintf("%d",sp);

   textcolor(7);

   for(i = -4;i < 9;i++)
   {
		gotoxy(70,13 + i);
		cprintf("          ");
		gotoxy(70,13 + i);
		textcolor(8);
		cprintf("%d:",sp + i);
		textcolor(7);
		behzad = 0;
		*((char *)&behzad) = *((char *)loadedfile + sp + i);
		gotoxy(78,13 + i);

		if(behzad < 16)
			cprintf("0");

		cprintf("%X",behzad);
   }

   textcolor(12);
   gotoxy(77,13);
   cprintf("%c",26);

   textcolor(14);
   gotoxy(18,5);

	for(int counter = 0;counter < 8;counter++)
	{
		behzad = 0;
		*((char *)&behzad) = *((char *)loadedfile + pc + counter);

		if(behzad < 16)
			cprintf("0");

		cprintf("%X ",behzad);
	}
}

void JVM::setinstructions()
{
//1
	for(int count = 0x0AC ;count <= 0x0C3;count++)
		*(alljobs + count) = JVM_UNDERCONST;

	*(alljobs + 0x0C5) = *(alljobs + 0x0C8) = 
	*(alljobs + 0x0C9) = *(alljobs + 0x0CA) = 
	*(alljobs + 0x0FE) = *(alljobs + 0x0FF) = 
	JVM_UNDERCONST;

	for(count = 0x0CB ;count <= 0x0FD;count++)
		*(alljobs + count) = JVM_4ANOTHERPROCESSORS;

	*(alljobs + 0x00) = JVM_NOP;
	*(alljobs + 0x01) = JVM_ACONST_NULL;
	*(alljobs + 0x02) = JVM_ICONST_m1;
	*(alljobs + 0x03) = JVM_ICONST_0;
	*(alljobs + 0x04) = JVM_ICONST_1;
	*(alljobs + 0x05) = JVM_ICONST_2;
	*(alljobs + 0x06) = JVM_ICONST_3;
	*(alljobs + 0x07) = JVM_ICONST_4;
	*(alljobs + 0x08) = JVM_ICONST_5;
	*(alljobs + 0x09) = JVM_LCONST_0;
	*(alljobs + 0x0A) = JVM_LCONST_1;
	*(alljobs + 0x0B) = JVM_FCONST_0;
	*(alljobs + 0x0C) = JVM_FCONST_1;
	*(alljobs + 0x0D) = JVM_FCONST_2;
	*(alljobs + 0x0E) = JVM_DCONST_0;
	*(alljobs + 0x0F) = JVM_DCONST_1;
	*(alljobs + 0x10) = JVM_BIPUSH;
	*(alljobs + 0x11) = JVM_SIPUSH;
	*(alljobs + 0x12) = JVM_LDC;
	*(alljobs + 0x13) = JVM_LDC_W;
	*(alljobs + 0x14) = JVM_LDC2_W;
//2
	*(alljobs + 0x15) = *(alljobs + 0x17) = JVM_ILOAD;
	*(alljobs + 0x16) = *(alljobs + 0x18) = JVM_LLOAD;
	*(alljobs + 0x19) = JVM_ALOAD;
	*(alljobs + 0x1A) = *(alljobs + 0x22) = JVM_ILOAD_0;
	*(alljobs + 0x1B) = *(alljobs + 0x23) = JVM_ILOAD_1;
	*(alljobs + 0x1C) = *(alljobs + 0x24) = JVM_ILOAD_2;
	*(alljobs + 0x1D) = *(alljobs + 0x25) = JVM_ILOAD_3;
	*(alljobs + 0x1E) = *(alljobs + 0x26) = JVM_LLOAD_0;
	*(alljobs + 0x1F) = *(alljobs + 0x27) = JVM_LLOAD_1;
	*(alljobs + 0x20) = *(alljobs + 0x28) = JVM_LLOAD_2;
	*(alljobs + 0x21) = *(alljobs + 0x29) = JVM_LLOAD_3;
	*(alljobs + 0x2A) = JVM_ALOAD_0;
	*(alljobs + 0x2B) = JVM_ALOAD_1;
	*(alljobs + 0x2C) = JVM_ALOAD_2;
	*(alljobs + 0x2D) = JVM_ALOAD_3;
	*(alljobs + 0x2E) = *(alljobs + 0x30) = JVM_IALOAD;
	*(alljobs + 0x2F) = *(alljobs + 0x31) = JVM_LALOAD;
	*(alljobs + 0x32) = *(alljobs + 0x34) = *(alljobs + 0x35) = JVM_AALOAD;
	*(alljobs + 0x33) = JVM_BALOAD;
//3
	*(alljobs + 0x36) = *(alljobs + 0x38) = JVM_ISTORE;
	*(alljobs + 0x37) = *(alljobs + 0x39) = JVM_LSTORE;
	*(alljobs + 0x3A) = JVM_ASTORE;
	*(alljobs + 0x3B) = *(alljobs + 0x43) = JVM_ISTORE_0;
	*(alljobs + 0x3C) = *(alljobs + 0x44) = JVM_ISTORE_1;
	*(alljobs + 0x3D) = *(alljobs + 0x45) = JVM_ISTORE_2;
	*(alljobs + 0x3E) = *(alljobs + 0x46) = JVM_ISTORE_3;
	*(alljobs + 0x3F) = *(alljobs + 0x47) = JVM_LSTORE_0;
	*(alljobs + 0x40) = *(alljobs + 0x48) = JVM_LSTORE_1;
	*(alljobs + 0x41) = *(alljobs + 0x49) = JVM_LSTORE_2;
	*(alljobs + 0x42) = *(alljobs + 0x4A) = JVM_LSTORE_3;
	*(alljobs + 0x4B) = JVM_ASTORE_0;
	*(alljobs + 0x4C) = JVM_ASTORE_1;
	*(alljobs + 0x4D) = JVM_ASTORE_2;
	*(alljobs + 0x4E) = JVM_ASTORE_3;
	*(alljobs + 0x4F) = *(alljobs + 0x51) = JVM_IASTORE;
	*(alljobs + 0x50) = *(alljobs + 0x52) = JVM_LASTORE;
	*(alljobs + 0x53) = *(alljobs + 0x55) = *(alljobs + 0x56) = JVM_AASTORE;
	*(alljobs + 0x54) = JVM_BASTORE;
//4
	*(alljobs + 0x57) = JVM_POP;
	*(alljobs + 0x58) = JVM_POP2;
	*(alljobs + 0x59) = JVM_DUP;
	*(alljobs + 0x5A) = JVM_DUP_X1;
	*(alljobs + 0x5B) = JVM_DUP_X2;
	*(alljobs + 0x5C) = JVM_DUP2;
	*(alljobs + 0x5D) = JVM_DUP2_X1;
	*(alljobs + 0x5E) = JVM_DUP2_X2;
	*(alljobs + 0x5F) = JVM_SWAP;
//5
	*(alljobs + 0x60) = JVM_IADD;
	*(alljobs + 0x61) = JVM_LADD;
	*(alljobs + 0x62) = JVM_FADD;
	*(alljobs + 0x63) = JVM_DADD;
	*(alljobs + 0x64) = JVM_ISUB;
	*(alljobs + 0x65) = JVM_LSUB;
	*(alljobs + 0x66) = JVM_FSUB;
	*(alljobs + 0x67) = JVM_DSUB;
	*(alljobs + 0x68) = JVM_IMUL;
	*(alljobs + 0x69) = JVM_LMUL;
	*(alljobs + 0x6A) = JVM_FMUL;
	*(alljobs + 0x6B) = JVM_DMUL;
	*(alljobs + 0x6C) = JVM_IDIV;
	*(alljobs + 0x6D) = JVM_LDIV;
	*(alljobs + 0x6E) = JVM_FDIV;
	*(alljobs + 0x6F) = JVM_DDIV;
	*(alljobs + 0x70) = JVM_IREM;
	*(alljobs + 0x71) = JVM_LREM;
	*(alljobs + 0x72) = JVM_FREM;
	*(alljobs + 0x73) = JVM_DREM;
	*(alljobs + 0x74) = JVM_INEG;
	*(alljobs + 0x75) = JVM_LNEG;
	*(alljobs + 0x76) = *(alljobs + 0x77) = JVM_FNEG;
	*(alljobs + 0x78) = JVM_ISHL;
	*(alljobs + 0x79) = JVM_LSHL;
	*(alljobs + 0x7A) = *(alljobs + 0x7C) = JVM_ISHR;
	*(alljobs + 0x7B) = *(alljobs + 0x7D) = JVM_LSHR;
	*(alljobs + 0x7E) = JVM_IAND;
	*(alljobs + 0x7F) = JVM_LAND;
	*(alljobs + 0x80) = JVM_IOR;
	*(alljobs + 0x81) = JVM_LOR;
	*(alljobs + 0x82) = JVM_IXOR;
	*(alljobs + 0x83) = JVM_LXOR;
	*(alljobs + 0x84) = JVM_IINC;
//6
	*(alljobs + 0x85) = JVM_I2L;
	*(alljobs + 0x86) = JVM_I2F;
	*(alljobs + 0x87) = JVM_I2D;
	*(alljobs + 0x88) = JVM_L2I;
	*(alljobs + 0x89) = JVM_L2F;
	*(alljobs + 0x8A) = JVM_L2D;
	*(alljobs + 0x8B) = JVM_F2I;
	*(alljobs + 0x8C) = JVM_F2L;
	*(alljobs + 0x8D) = JVM_F2D;
	*(alljobs + 0x8E) = JVM_D2I;
	*(alljobs + 0x8F) = JVM_D2L;
	*(alljobs + 0x90) = JVM_D2F;
	*(alljobs + 0x91) = JVM_I2B;
	*(alljobs + 0x92) = *(alljobs + 0x93) = JVM_I2C;
//7
	*(alljobs + 0x94) = JVM_LCMP;
	*(alljobs + 0x95) = *(alljobs + 0x96) = JVM_FCMP;
	*(alljobs + 0x97) = *(alljobs + 0x98) = JVM_DCMP;
	*(alljobs + 0x99) = JVM_IF_EQ;
	*(alljobs + 0x9A) = JVM_IF_NE;
	*(alljobs + 0x9B) = JVM_IF_LT;
	*(alljobs + 0x9C) = JVM_IF_GE;
	*(alljobs + 0x9D) = JVM_IF_GT;
	*(alljobs + 0x9E) = JVM_IF_LE;
	*(alljobs + 0x9F) = JVM_IF_ICMPEQ;
	*(alljobs + 0xA0) = JVM_IF_ICMPNE;
	*(alljobs + 0xA1) = JVM_IF_ICMPLT;
	*(alljobs + 0xA2) = JVM_IF_ICMPGE;
	*(alljobs + 0xA3) = JVM_IF_ICMPGT;
	*(alljobs + 0xA4) = JVM_IF_ICMPLE;
	*(alljobs + 0xA5) = JVM_IF_ACMPEQ;
	*(alljobs + 0xA6) = JVM_IF_ACMPNE;
	*(alljobs + 0xA7) = JVM_GOTO;
	*(alljobs + 0xA8) = JVM_JSR;
	*(alljobs + 0xA9) = JVM_RET;
	*(alljobs + 0xAA) = JVM_TABLESWITCH;
	*(alljobs + 0xAB) = JVM_LOOKUPSWITCH;
	*(alljobs + 0xB9) = JVM_INVOKEINTERFACE;
	*(alljobs + 0xC4) = JVM_WIDE;
	*(alljobs + 0xC6) = JVM_IFNULL;
	*(alljobs + 0xC7) = JVM_IFNONNULL;
}

void JVM::memmanager()
{
	textcolor(4);
	gotoxy(22,15);
	cprintf("Where:            ");
	_setcursortype(_NORMALCURSOR);
	gotoxy(29,15);
	getint(wherethemem);
	_setcursortype(_NOCURSOR);
	drawtable(wherethemem);
}

void JVM::drawtable(int where)
{
	int counter;
	short behzad;

	for(int count = 0;count < 13;count++)
	{
		gotoxy(1,9 + count);
		cprintf("      ");
		gotoxy(1,9 + count);
		textcolor(8);
		cprintf("%d: ",where + 16 * count);
		gotoxy(8,9 + count);
		textcolor(7);

		for(counter = 0;counter < 16;counter++)
		{
			behzad = 0;
			*((char *)&behzad) = *((char *)loadedfile + where + 16 * count + counter);

			if(behzad < 16)
				cprintf("0");

			cprintf("%X ",behzad);
		}
	}

	textcolor(12);
	gotoxy(7,9);
	cprintf("%c",26);
}

void JVM::finalize()
{
	if(loadedfile)
		free(loadedfile);
	if(alljobs)
		delete [] alljobs;
	if(mystream)
		fclose(mystream);

	loadedfile = alljobs = NULL;
	mystream = NULL;
}

//587 Lines